#include "types.r"

resource 'MENU' (128, preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129, preload) {
	129,
	textMenuProc,
	0xFFF,
	enabled,
	"File",
	{	/* array: 1 elements */
		/* [1] */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130, preload) {
	130,
	textMenuProc,
	0x3400,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (131) {
	131,
	textMenuProc,
	allEnabled,
	enabled,
	"Interact",
	{	/* array: 3 elements */
		/* [1] */
		"Interact With Self", noIcon, noKey, noMark, plain,
		/* [2] */
		"Interact with Local", noIcon, noKey, noMark, plain,
		/* [3] */
		"Interact with All", noIcon, noKey, noMark, plain
	}
};

resource 'MBAR' (128) {
	{	/* array MenuArray: 4 elements */
		/* [1] */
		128,
		/* [2] */
		129,
		/* [3] */
		130,
		/* [4] */
		131
	}
};

resource 'WIND' (128) {
	{40, 40, 120, 346},
	documentProc,
	visible,
	noGoAway,
	0x0,
	"Receiver"
	/****** Extra bytes follow... ******/
	/* $"0A30 0A"                                            /* .0. */
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	50000,
	50000
};

resource 'BNDL' (128) {
	'MuuB',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

data 'MuuB' (0, "Owner resource") {
	$"00"                                                 /* . */
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'ICN#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"000F F000 0070 0E00 0180 0180 030F F0C0"
		$"0438 1C20 08C0 0310 1180 0188 3200 00CC"
		$"2607 E064 4418 1822 4820 0C12 4840 0612"
		$"9840 0219 9080 0109 9083 8109 9083 C109"
		$"9083 C109 9081 8109 9080 0109 9840 0219"
		$"4860 0612 4830 0C12 4418 1822 2607 E064"
		$"3300 00CC 1180 0188 08C0 0310 0438 1C20"
		$"030F F0C0 0180 0180 0070 0E00 000F F0",
		/* [2] */
		$"000F F000 007F FE00 01FF FF80 03FF FFC0"
		$"07FF FFE0 0FFF FFF0 1FFF FFF8 3FFF FFFC"
		$"3FFF FFFC 7FFF FFFE 7FFF FFFE 7FFF FFFE"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF 7FFF FFFE 7FFF FFFE 7FFF FFFE"
		$"3FFF FFFC 3FFF FFFC 1FFF FFF8 0FFF FFF0"
		$"07FF FFE0 03FF FFC0 01FF FF80 007F FE"
	}
};

resource 'ALRT' (444) {
	{40, 40, 124, 275},
	444,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
	/****** Extra bytes follow... ******/
	/* $"280A"                                               /* (. */
};

resource 'ALRT' (128) {
	{40, 40, 228, 332},
	128,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (444) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{50, 90, 70, 148},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 10, 29, 237},
		StaticText {
			disabled,
			"Sample Required Interaction"
		}
	}
};

resource 'DITL' (128) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{164, 115, 184, 185},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{5, 10, 43, 290},
		StaticText {
			disabled,
			"AppleEvents Interaction \n Sampler recei"
			"ver"
		},
		/* [3] */
		{76, 3, 154, 301},
		StaticText {
			disabled,
			"FredWare from Apple Developer Technical "
			"Support, ADS group.\nCopyright   1991 Ap"
			"ple Computer Inc.\nWritten by C.K. Haun ("
			"<TR>)."
		},
		/* [4] */
		{53, 82, 71, 227},
		StaticText {
			disabled,
			"version 1.0d1"
		}
	}
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0FF0 1BD8 2E74 581A F7EF AC35 E817 C993"
		$"C993 E817 AC35 F7EF 581A 2E74 1BD8 0FF0",
		/* [2] */
		$"0FF0 1FF8 3FFC 7FFE FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF 7FFE 3FFC 1FF8"
	}
};

resource 'icl8' (128) {
	$"0000 0000 0000 0000 0000 0000 FFFF FFFF"
	$"FFFF FFFF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF FFFF 4848 4848"
	$"4848 4848 FFFF FF00 0000 0000 0000 0000"
	$"0000 0000 0000 00FF FF48 4848 4848 4848"
	$"4848 4848 4848 48FF FF00 0000 0000 0000"
	$"0000 0000 0000 FFFF 4848 4848 FFFF FFFF"
	$"FFFF FFFF 4848 4848 FFFF 0000 0000 0000"
	$"0000 0000 00FF 4848 4848 FFFF FFC0 C0C0"
	$"C0C0 C0FF FFFF 4848 4848 FF00 0000 0000"
	$"0000 0000 FF48 4848 FFFF C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 FFFF 4848 48FF 0000 0000"
	$"0000 00FF 4848 48FF FFC0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0FF FF48 4848 FF00 0000"
	$"0000 FFFF 4848 FFC0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 FFFF 4848 FFFF 0000"
	$"0000 FF48 48FF FFC0 C0C0 C0C0 C0FF FFFF"
	$"FFFF FFC0 C0C0 C0C0 C0FF FF48 48FF 0000"
	$"00FF 4848 48FF C0C0 C0C0 C0FF FFEC ECEC"
	$"ECEC ECFF FFC0 C0C0 C0C0 FF48 4848 FF00"
	$"00FF 4848 FFC0 C0C0 C0C0 FFEC ECEC ECEC"
	$"ECEC ECEC FFFF C0C0 C0C0 C0FF 4848 FF00"
	$"00FF 4848 FFC0 C0C0 C0FF ECEC ECEC ECEC"
	$"ECEC ECEC ECFF FFC0 C0C0 C0FF 4848 FF00"
	$"FF48 48FF FFC0 C0C0 C0FF ECEC ECEC ECEC"
	$"ECEC ECEC ECEC FFC0 C0C0 C0FF FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC ECEC"
	$"ECEC ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC FFFF"
	$"FFEC ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC FFFF"
	$"FFFF ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC FFFF"
	$"FFFF ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC ECFF"
	$"FFEC ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF C0C0 C0C0 FFEC ECEC ECEC ECEC"
	$"ECEC ECEC ECEC ECFF C0C0 C0C0 FF48 48FF"
	$"FF48 48FF FFC0 C0C0 C0FF ECEC ECEC ECEC"
	$"ECEC ECEC ECEC FFC0 C0C0 C0FF FF48 48FF"
	$"00FF 4848 FFC0 C0C0 C0FF FFEC ECEC ECEC"
	$"ECEC ECEC ECFF FFC0 C0C0 C0FF 4848 FF00"
	$"00FF 4848 FFC0 C0C0 C0C0 FFFF ECEC ECEC"
	$"ECEC ECEC FFFF C0C0 C0C0 C0FF 4848 FF00"
	$"00FF 4848 48FF C0C0 C0C0 C0FF FFEC ECEC"
	$"ECEC ECFF FFC0 C0C0 C0C0 FF48 4848 FF00"
	$"0000 FF48 48FF FFC0 C0C0 C0C0 C0FF FFFF"
	$"FFFF FFC0 C0C0 C0C0 C0FF FF48 48FF 0000"
	$"0000 FFFF 4848 FFFF C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 FFFF 4848 FFFF 0000"
	$"0000 00FF 4848 48FF FFC0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0FF FF48 4848 FF00 0000"
	$"0000 0000 FF48 4848 FFFF C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 FFFF 4848 48FF 0000 0000"
	$"0000 0000 00FF 4848 4848 FFFF FFC0 C0C0"
	$"C0C0 C0FF FFFF 4848 4848 FF00 0000 0000"
	$"0000 0000 0000 FFFF 4848 4848 FFFF FFFF"
	$"FFFF FFFF 4848 4848 FFFF 0000 0000 0000"
	$"0000 0000 0000 00FF FF48 4848 4848 4848"
	$"4848 4848 4848 48FF FF00 0000 0000 0000"
	$"0000 0000 0000 0000 00FF FFFF 4848 4848"
	$"4848 4848 FFFF FF00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FFFF FFFF"
	$"FFFF FFFF"
};

resource 'icl4' (128) {
	$"0000 0000 0000 FFFF FFFF 0000 0000 0000"
	$"0000 0000 0FFF 0000 0000 FFF0 0000 0000"
	$"0000 000F F000 0000 0000 000F F000 0000"
	$"0000 00FF 0000 FFFF FFFF 0000 FF00 0000"
	$"0000 0F00 00FF F777 777F FF00 00F0 0000"
	$"0000 F000 FF77 7777 7777 77FF 000F 0000"
	$"000F 000F F777 7777 7777 777F F000 F000"
	$"00FF 00F7 7777 7777 7777 7777 FF00 FF00"
	$"00F0 0FF7 7777 7FFF FFF7 7777 7FF0 0F00"
	$"0F00 0F77 777F F666 666F F777 77F0 00F0"
	$"0F00 F777 77F6 6666 6666 FF77 777F 00F0"
	$"0F00 F777 7F66 6666 6666 6FF7 777F 00F0"
	$"F00F F777 7F66 6666 6666 66F7 777F F00F"
	$"F00F 7777 F666 6666 6666 666F 7777 F00F"
	$"F00F 7777 F666 66FF F666 666F 7777 F00F"
	$"F00F 7777 F666 66FF FF66 666F 7777 F00F"
	$"F00F 7777 F666 66FF FF66 666F 7777 F00F"
	$"F00F 7777 F666 666F F666 666F 7777 F00F"
	$"F00F 7777 F666 6666 6666 666F 7777 F00F"
	$"F00F F777 7F66 6666 6666 66F7 777F F00F"
	$"0F00 F777 7FF6 6666 6666 6FF7 777F 00F0"
	$"0F00 F777 77FF 6666 6666 FF77 777F 00F0"
	$"0F00 0F77 777F F666 666F F777 77F0 00F0"
	$"00F0 0FF7 7777 7FFF FFF7 7777 7FF0 0F00"
	$"00FF 00FF 7777 7777 7777 7777 FF00 FF00"
	$"000F 000F F777 7777 7777 777F F000 F000"
	$"0000 F000 FF77 7777 7777 77FF 000F 0000"
	$"0000 0F00 00FF F777 777F FF00 00F0 0000"
	$"0000 00FF 0000 FFFF FFFF 0000 FF00 0000"
	$"0000 000F F000 0000 0000 000F F000 0000"
	$"0000 0000 0FFF 0000 0000 FFF0 0000 0000"
	$"0000 0000 0000 FFFF FFFF"
};

resource 'ics8' (128) {
	$"0000 0000 FFFF FFFF FFFF FFFF 0000 0000"
	$"0000 00FF FF48 FFFF FFFF 48FF FF00 0000"
	$"0000 FF48 FFFF FFC0 C0FF FFFF 48FF 0000"
	$"00FF 48FF FFC0 C0C0 C0C0 C0FF FF48 FF00"
	$"FFFF FFFF C0FF FFFF FFFF FFC0 FFFF FFFF"
	$"FF48 FFC0 FFFF ECEC ECEC FFFF C0FF 48FF"
	$"FFFF FFC0 FFEC ECEC ECEC ECFF C0FF FFFF"
	$"FFFF C0C0 FFEC ECFF FFEC ECFF C0C0 FFFF"
	$"FFFF C0C0 FFEC ECFF FFEC ECFF C0C0 FFFF"
	$"FFFF FFC0 FFEC ECEC ECEC ECFF C0FF FFFF"
	$"FF48 FFC0 FFFF ECEC ECEC FFFF C0FF 48FF"
	$"FFFF FFFF C0FF FFFF FFFF FFC0 FFFF FFFF"
	$"00FF 48FF FFC0 C0C0 C0C0 C0FF FF48 FF00"
	$"0000 FF48 FFFF FFC0 C0FF FFFF 48FF 0000"
	$"0000 00FF FF48 FFFF FFFF 48FF FF00 0000"
	$"0000 0000 FFFF FFFF FFFF FFFF"
};

resource 'ics4' (128) {
	$"0000 FFFF FFFF 0000 000F F0FF FF0F F000"
	$"00F0 FFF7 7FFF 0F00 0F0F F777 777F F0F0"
	$"FFFF 7FFF FFF7 FFFF F0F7 FF66 66FF 7F0F"
	$"FFF7 F666 666F 7FFF FF77 F66F F66F 77FF"
	$"FF77 F66F F66F 77FF FFF7 F666 666F 7FFF"
	$"F0F7 FF66 66FF 7F0F FFFF 7FFF FFF7 FFFF"
	$"0F0F F777 777F F0F0 00F0 FFF7 7FFF 0F00"
	$"000F F0FF FF0F F000 0000 FFFF FFFF"
};

data 'CODE' (0, purgeable) {
	$"0000 0068 0000 02DC 0000 0048 0000 0020"            /* ...h.......H...  */
	$"05AA 3F3C 0001 A9F0 044E 3F3C 0001 A9F0"            /* .?<....N?<... */
	$"0470 3F3C 0001 A9F0 0492 3F3C 0001 A9F0"            /* .p?<....?<... */
	$"04B6 3F3C 0001 A9F0 04DE 3F3C 0001 A9F0"            /* .?<.....?<... */
	$"0532 3F3C 0001 A9F0 06FE 3F3C 0001 A9F0"            /* .2?<.....?<... */
	$"0000 3F3C 0002 A9F0"                                /* ..?<... */
};

data 'CODE' (1, "Main", locked, preload) {
	$"0000 0008 4E56 FFFC A063 486D FE7E A86E"            /* ....NV..cHm.~n */
	$"A8FE A912 A930 A9CC 7000 2F00 A97B A850"            /* ..0p./.{P */
	$"4EBA 037E 598F 3F3C 0080 A9C0 2B57 FD8C"            /* N.~Y?<.+W. */
	$"A93C 598F 3F3C 0080 A949 2B5F FD9C 598F"            /* <Y?<.I+_.Y */
	$"3F3C 0081 A949 2B5F FD98 598F 3F3C 0082"            /* ?<.I+_.Y?<. */
	$"A949 2B5F FD94 598F 3F3C 0083 A949 2B5F"            /* I+_.Y?<.I+_ */
	$"FD90 2F2D FD9C 2F3C 4452 5652 A94D A937"            /* ./-./<DRVRM7 */
	$"2F2D FD90 3F2D FD76 7001 1F00 A945 598F"            /* /-.?-.vp...EY */
	$"3F3C 0080 7000 2F00 72FF 2F01 A9BD 584F"            /* ?<.p./.r./.XO */
	$"558F 70FF 3F00 486D FD78 721E 2F01 7000"            /* Up.?.Hm.xr./.p. */
	$"2F00 A860 302D FD78 544F 6B00 0142 0C40"            /* /.`0-.xTOk..B.@ */
	$"0017 6E00 013A D040 303B 0006 4EFB 0000"            /* ..n..:@0;..N... */
	$"0130 0044 0130 00B8 0130 00B8 0036 00DA"            /* .0.D.0..0..6.. */
	$"00E6 0130 0130 0130 0130 0130 0130 00FC"            /* ...0.0.0.0.0.0.. */
	$"0130 0130 0130 0130 0130 0130 0130 0126"            /* .0.0.0.0.0.0.0.& */
	$"6000 00FC 2F2D FD7A 4EBA 019C 584F 6000"            /* `.../-.zN.XO`. */
	$"00EE 558F 2F2D FD82 486E FFFC A92C 301F"            /* ..U/-.Hn..,0. */
	$"6B00 00DC 0C40 0006 6E00 00D4 D040 303B"            /* k....@..n..@0; */
	$"0006 4EFB 0000 00CA 0014 0026 00CA 0034"            /* ..N.......&..4 */
	$"00CA 00CA 6000 00B8 598F 2F2D FD82 A93D"            /* ..`..Y/-.= */
	$"4EBA 019A 584F 6000 00A6 486D FD78 2F2E"            /* N.XO`..Hm.x/. */
	$"FFFC A9B3 6000 0098 598F A924 202E FFFC"            /* ..`..Y$ ... */
	$"B09F 6600 008A 2F2E FFFC 2F2D FD82 486D"            /* f../.../-.Hm */
	$"FE0A A925 6078 303C 0100 C06D FD86 676E"            /* ..%`x0<..m.gn */
	$"598F 203C 0000 00FF C0AD FD7A 3F00 A93E"            /* Y <.....z?.> */
	$"4EBA 014A 584F 6056 2F2D FD7A 4EBA 00A4"            /* N.JXO`V/-.zN. */
	$"584F 604A 302D FD86 0800 0000 6740 2F2D"            /* XO`J0-.....g@/- */
	$"FD7A 4EBA 00E2 584F 6034 202D FD7A 4840"            /* .zN..XO`4 -.zH@ */
	$"48C0 E040 223C 0000 00FF C280 5381 661E"            /* H.@"<....Sf. */
	$"7001 C0AD FD7A 57C0 0240 0001 48C0 1B40"            /* p..zW.@..H.@ */
	$"FD88 600A 486D FD78 4EBA 0246 584F 7000"            /* .`.Hm.xN.FXOp. */
	$"102D FD8A 0C40 0001 6600 FE96 4E5E 4E75"            /* .-..@..f..N^Nu */
	$"846D 6169 6E00 0000 4E56 FF00 48E7 0108"            /* main...NV..H... */
	$"49EE FF00 2F2E 0008 3F2E 000E 2F0C A946"            /* I.../...?.../.F */
	$"558F 2F0C A9B6 301F 48C0 2E00 4CEE 1080"            /* U/.0.H..L.. */
	$"FEF8 4E5E 4E75 8844 6F44 6143 616C 6C00"            /* ..N^NuDoDaCall. */
	$"0000 4E56 FFFC 48E7 0700 2E2E 0008 3D7C"            /* ..NV..H.......=| */
	$"0028 FFFE 3D7C 0028 FFFC 558F 2F07 A86A"            /* .(..=|.(..U/.j */
	$"3C1F 558F 2F07 A86B 3A1F 4A46 670E 558F"            /* <.U/.k:.JFg.U */
	$"2F2E FFFC 2F07 4EBA 0A66 3C1F 4CEE 00E0"            /* /.../.N.f<.L... */
	$"FFF0 4E5E 4E75 8C44 6F44 6973 6B45 7665"            /* ..N^NuDoDiskEve */
	$"6E74 7300 0000 4E56 0000 2F0C 286E 0008"            /* nts...NV../.(n.. */
	$"2F0C A922 2F0C A873 7028 3F00 7246 3F01"            /* /."/.sp(?.rF?. */
	$"A893 7001 3F00 A888 7014 3F00 A88A 486D"            /* p.?.p.?.Hm */
	$"FD26 A884 2F0C A923 286E FFFC 4E5E 4E75"            /* .&/.#(n..N^Nu */
	$"8844 7261 774D 6169 6E00 0000 4E56 0000"            /* DrawMain...NV.. */
	$"48E7 0708 49ED FDA0 2C2E 0008 4207 558F"            /* H...I..,...B.U */
	$"2F06 A86B 3E1F 558F 2F06 A86A 3A1F 3005"            /* /.k>.U/.j:.0. */
	$"0440 0080 6B7C 0C40 0003 6E76 D040 303B"            /* .@.k|.@..nv@0; */
	$"0006 4EFB 0000 000A 0030 006E 0038 0C47"            /* ..N......0.n.8.G */
	$"0001 6710 48C7 2F07 2F2D FD9C 4EBA FEDA"            /* ..g.H/./-.N.. */
	$"504F 604E 558F 3F3C 0080 7000 2F00 A985"            /* PO`NU?<.p./. */
	$"544F 603E 1B7C 0001 FD8A 6036 BE6D FD76"            /* TO`>.|...`6m.v */
	$"6730 2F2D FD90 3F2D FD76 7000 1F00 A945"            /* g0/-.?-.vp...E */
	$"2F2D FD90 3F07 7001 1F00 A945 558F 2007"            /* /-.?.p...EU . */
	$"D040 1F34 0001 303C 011E A816 3B47 FD76"            /* @.4..0<...;G.v */
	$"544F 7000 3F00 A938 4CEE 10E0 FFF0 4E5E"            /* TOp.?.8L.....N^ */
	$"4E75 8A44 6F53 656C 6563 7465 6400 0000"            /* NuDoSelected... */
	$"4E56 FFFC 48E7 1308 49ED FD3A 4246 7000"            /* NV..H...I..:BFp. */
	$"2D40 FFFC 4207 558F 2F3C 6576 6E74 486E"            /* -@..B.U/<evntHn */
	$"FFFC 4EBA 0702 4A5F 57C0 0240 0001 48C0"            /* ..N..J_W.@..H */
	$"1E00 6742 7E00 558F 2007 C1FC 000C 2F34"            /* ..gB~.U ..../4 */
	$"0000 2007 C1FC 000C 2F34 0004 2007 C1FC"            /* .. ..../4.. .. */
	$"000C 2F34 0008 7000 2F00 7200 1F01 303C"            /* ../4..p./.r...0< */
	$"091F A816 3C1F 6702 A9F4 2007 5287 7005"            /* ..<.g.. .Rp. */
	$"B087 6EC2 6002 A9F4 4CEE 10C8 FFEC 4E5E"            /* n`..L....N^ */
	$"4E75 8B49 6E69 7441 4553 7475 6666 0000"            /* NuInitAEStuff.. */
	$"4E56 0000 558F 2F2E 0008 303C 021B A816"            /* NV..U/...0<... */
	$"4E5E 4E75 8B44 6F48 6967 684C 6576 656C"            /* N^NuDoHighLevel */
	$"0000 4E56 0000 426E 0014 4E5E 205F 4FEF"            /* ..NV..Bn..N^ _O. */
	$"000C 4ED0 8D41 454F 5045 4E48 414E 444C"            /* ..NЍAEOPENHANDL */
	$"4552 0000 4E56 0000 4E5E 205F 4FEF 000C"            /* ER..NV..N^ _O... */
	$"4ED0 9041 454F 5045 4E44 4F43 4841 4E44"            /* NАAEOPENDOCHAND */
	$"4C45 5200 0000 4E56 0000 426E 0014 4E5E"            /* LER...NV..Bn..N^ */
	$"205F 4FEF 000C 4ED0 8E41 4550 5249 4E54"            /*  _O...NЎAEPRINT */
	$"4841 4E44 4C45 5200 0000 4E56 0000 1B7C"            /* HANDLER...NV...| */
	$"0001 FD8A 426E 0014 4E5E 205F 4FEF 000C"            /* ...Bn..N^ _O... */
	$"4ED0 8D41 4551 5549 5448 414E 444C 4552"            /* NЍAEQUITHANDLER */
	$"0000 4E56 0000 2F07 558F 70FF 2F00 7200"            /* ..NV../.Up./.r. */
	$"2F01 486D 0052 303C 061C A816 3E1F 0C47"            /* /.Hm.R0<...>..G */
	$"F94F 670E 558F 3F3C 01BC 7000 2F00 A985"            /* .Og.U?<.p./. */
	$"544F 426E 0014 2E2E FFFC 4E5E 205F 4FEF"            /* TOBn......N^ _O. */
	$"000C 4ED0 8F41 4553 494D 504C 4548 414E"            /* ..NЏAESIMPLEHAN */
	$"444C 4552 0000 4E56 0000 2F0C 286E 0010"            /* DLER..NV../.(n.. */
	$"3014 670E 5D40 6718 5540 6714 5F40 671C"            /* 0.g.]@g.U@g._@g. */
	$"6042 206E 000C 7000 2080 2D40 0008 6034"            /* `B n..p. -@..`4 */
	$"2F2C 0002 4EBA FD30 584F 6028 202D FD7A"            /* /,..N.0XO`( -.z */
	$"4840 48C0 E040 223C 0000 00FF C280 5381"            /* H@H.@"<....S */
	$"6612 7001 C0AD FD7A 57C0 0240 0001 48C0"            /* f.p..zW.@..H */
	$"1B40 FD88 286E FFFC 4E5E 205F 4FEF 000C"            /* .@.(n..N^ _O... */
	$"4ED0 8849 444C 4550 524F 4300 0000 2057"            /* NЈIDLEPROC... W */
	$"42A7 486D FDB0 486D FDAC 486D FDA8 2F08"            /* BHm.Hm.Hm./. */
	$"4EBA 01C8 72FF B041 672E 588F 4FEF 0010"            /* N.r.Ag.XO... */
	$"486D FFD0 4EBA 04C4 584F 4A80 6624 2F2D"            /* Hm.N.XOJf$/- */
	$"FDB0 2F2D FDAC 2F2D FDA8 4EBA FA18 4FEF"            /* ./-./-.N..O. */
	$"000C 2F00 4EBA 038C 487A 000A 303C FE15"            /* ../.N.Hz..0<.. */
	$"A9C9 4E75 1B44 6174 6120 696E 6974 6961"            /* Nu.Data initia */
	$"6C69 7A61 7469 6F6E 2066 6169 6C65 6421"            /* lization failed! */
	$"4E56 FFFC 48E7 0318 4A6D FED8 6600 00BC"            /* NV..H...Jm.f.. */
	$"598F 2F3C 434F 4445 486D FE82 A820 285F"            /* Y/<CODEHm. (_ */
	$"200C 6700 00A6 558F A994 558F 2F0C A9A4"            /*  .g..UU/. */
	$"301F B05F 6600 0094 41ED 005A 226D FEF4"            /* 0._f..A..Z"m.. */
	$"2348 000C 2654 3013 0800 0000 6708 3B7C"            /* #H..&T0.....g.;| */
	$"0028 FED6 6006 3B7C 0004 FED6 598F 2F0C"            /* .(.`.;|...Y/. */
	$"4EBA 0436 302D FED6 48C0 221F 9280 2001"            /* N.60-.H". . */
	$"7204 4EBA 0378 2C00 7000 2640 6036 2F0C"            /* r.N.x,.p.&@`6/. */
	$"A9A2 302D FED6 48C0 D094 2D40 FFFC 302D"            /* 0-.HД-@..0- */
	$"FED8 48C0 206E FFFC E580 3030 0800 48C0"            /* .H n...00..H */
	$"2E00 6708 200D 2640 D7C7 4E93 302D FED8"            /* ..g. &@N0-. */
	$"526D FED8 302D FED8 48C0 BC80 6EC0 200B"            /* Rm.0-.Hn . */
	$"6704 2F0B A9F1 2F0C A9A3 4CEE 18C0 FFEC"            /* g./../.L.... */
	$"4E5E 4E75 8B5F 5F43 706C 7573 496E 6974"            /* N^Nu__CplusInit */
	$"0000 4E56 FFFC 48E7 0118 4A6D FED8 6764"            /* ..NV..H...Jm.gd */
	$"598F 2F3C 434F 4445 486D FEAC A9A1 285F"            /* Y/<CODEHm.(_ */
	$"200C 6750 558F A994 558F 2F0C A9A4 301F"            /*  .gPUU/.0. */
	$"B05F 6640 6034 2F0C A9A2 302D FED6 48C0"            /* _f@`4/.0-.H */
	$"D094 2D40 FFFC 536D FED8 302D FED8 48C0"            /* Д-@..Sm.0-.H */
	$"206E FFFC E580 3030 0802 48C0 2E00 200D"            /*  n...00..H..  */
	$"2640 D7C7 4A87 6702 4E93 4A6D FED8 6EC6"            /* &@Jg.NJm.n */
	$"2F0C A9A3 4CEE 1880 FFF0 4E5E 4E75 8964"            /* /.L....N^Nud */
	$"746F 7273 5F5F 4676 0000 4E56 0000 48E7"            /* tors__Fv..NV..H. */
	$"1338 2E2E 0018 266E 000C 4EAD 0062 4A80"            /* .8....&n..N.bJ */
	$"6706 70FF 6000 01C8 206D FEF4 20AE 0008"            /* g.p.`.. m.. .. */
	$"7601 4AB8 0316 672C 7001 C0B8 0316 6624"            /* v.J..g,p...f$ */
	$"2078 0316 0C90 4D50 474D 6618 2078 0316"            /*  x...MPGMf. x.. */
	$"4AA8 0004 670E 2078 0316 2068 0004 4A50"            /* J..g. x.. h..JP */
	$"6702 7600 4883 48C3 2B43 FEDA 6760 41ED"            /* g.v.HH+C..g`A. */
	$"FFAE 43F8 0910 7007 20D9 51C8 FFFC 30D9"            /* .C..p. .Q..0. */
	$"41ED FFAE 226D FEE4 2288 4A87 660E 598F"            /* A.."m.."Jf.Y */
	$"206D FEE4 2F10 4EBA 0502 584F 200B 6704"            /*  m../.N..XO .g. */
	$"7001 2680 4AAE 0010 6708 206E 0010 20AD"            /* p.&J..g. n..  */
	$"FEE4 4AAE 0014 6708 206E 0014 20AD FEE8"            /* ..J..g. n.. .. */
	$"4EBA FDDE 7001 2B40 FEDA 6000 0122 2078"            /* N..p.+@..`.." x */
	$"0316 2068 0004 302D FEDE B050 670C 2F3C"            /* .. h..0-..Pg./< */
	$"8000 0000 4EBA 013C 584F 41ED FEDE 2278"            /* ...N.<XOA..."x */
	$"0316 2269 0004 2348 0024 2078 0316 2B68"            /* .."i..#H.$ x..+h */
	$"0004 FF02 2078 0316 2068 0004 2B68 0002"            /* .... x.. h..+h.. */
	$"FEE0 2078 0316 2068 0004 2B68 0006 FEE4"            /* .. x.. h..+h.... */
	$"2078 0316 2068 0004 2B68 000A FEE8 4A87"            /*  x.. h..+h....J */
	$"672C 286D FEE4 600C 598F 2F14 4EBA 0426"            /* g,(m..`.Y/.N.& */
	$"584F 584C 4A94 66F0 286D FEE8 600C 598F"            /* XOXLJf.(m..`.Y */
	$"2F14 4EBA 0410 584F 584C 4A94 66F0 200B"            /* /.N..XOXLJf. . */
	$"6704 26AD FEE0 4AAE 0010 6708 206E 0010"            /* g.&..J..g. n.. */
	$"20AD FEE4 4AAE 0014 6708 206E 0014 20AD"            /*  ..J..g. n..  */
	$"FEE8 2078 0316 2068 0004 4AA8 0020 6754"            /* .. x.. h..J. gT */
	$"7078 A11E 2B48 FEFE 660A 7002 2F00 4EBA"            /* px.+H..f.p./.N */
	$"0082 584F 2078 0316 2068 0004 2668 0020"            /* .XO x.. h..&h.  */
	$"7E00 7605 2207 2001 C2FC 0018 4840 C0FC"            /* ~.v.". ....H@. */
	$"0018 4840 4240 D280 2C01 206D FEFE 43F3"            /* ..H@B@Ҁ,. m..C. */
	$"6800 45F0 6800 7005 24D9 51C8 FFFC 5287"            /* h.E.h.p.$.Q..R */
	$"B687 6ED0 4EBA FCBA 7000 2B40 FEDA 4CEE"            /* nN.p.+@..L. */
	$"1CC8 FFE8 4E5E 4E75 875F 5254 496E 6974"            /* ...N^Nu_RTInit */
	$"0000 4E56 0000 203C 00FF FFFF C0AE 0008"            /* ..NV.. <...... */
	$"2F00 4EBA 000E 4E5E 4E75 8465 7869 7400"            /* /.N..N^Nuexit. */
	$"0000 4E56 0000 2F0C 206D FEF4 49E8 008C"            /* ..NV../. m..I.. */
	$"600A 4A94 6704 2054 4E90 594C 206D FEF4"            /* `.Jg. TNYL m.. */
	$"B1CC 65EE 4AAD FF02 670A 206D FF02 216E"            /* e.J..g. m..!n */
	$"0008 000E 4AAD FFE8 660A 206D FEF4 2250"            /* ....J..f. m.."P */
	$"4E91 600E 7001 2F00 486D FFD0 4EBA 00B8"            /* N`.p./.Hm.N. */
	$"504F 286E FFFC 4E5E 4E75 875F 5254 4578"            /* PO(n..N^Nu_RTEx */
	$"6974 0000 222F 0004 202F 0008 4EBA 000E"            /* it.."/.. /..N.. */
	$"2001 4E75 222F 0004 202F 0008 48E7 0600"            /*  .Nu"/.. /..H... */
	$"2A00 6A02 4480 2C01 6A02 4481 4EBA 001C"            /* *.j.D,.j.DN.. */
	$"4A85 6A02 4480 BB86 6A02 4481 4CDF 0060"            /* Jj.Dj.DL..` */
	$"4E75 222F 0004 202F 0008 48E7 3800 2401"            /* Nu"/.. /..H.8.$. */
	$"4842 4A42 661C 3600 4240 4840 6704 80C1"            /* HBJBf.6.B@H@g. */
	$"3400 4842 3003 80C1 3400 2202 4240 4840"            /* 4.HB0.4.".B@H@ */
	$"6022 2400 4240 4840 4842 4242 2601 7200"            /* `"$.B@H@HBBB&.r. */
	$"780F D482 D180 D281 B083 6504 9083 5201"            /* x.Ԃрҁe.R. */
	$"51CC FFF0 4CDF 001C 4E75 225F 2057 48D0"            /* Q..L...Nu"_ WH */
	$"DEFC 7000 4ED1 202F 0008 6602 7001 206F"            /* ..p.N /..f.p. o */
	$"0004 4CD0 DEFC 4ED1 225F 205F A025 2E80"            /* ..L..N"_ _%. */
	$"6A02 4297 4ED1 4E56 0000 203C 0000 A89F"            /* j.BNNV.. <.. */
	$"A746 2F08 203C 0000 A0AD A346 B1DF 670E"            /* F/. <..F.g. */
	$"202E 000C A1AD 226E 0008 2288 6026 41FA"            /*  ..."n.."`&A. */
	$"0036 303C EA51 222E 000C B298 6706 4A98"            /* .60<.Q"...g.J */
	$"6712 60F6 43FA 0020 D3D0 4ED1 226E 0008"            /* g.`.C.. N"n.. */
	$"2280 4240 3D40 0010 4E5E 205F 508F 4ED0"            /* "B@=@..N^ _PN */
	$"303C EA52 60EE 7665 7273 0000 0060 6D61"            /* 0<.R`.vers...`ma */
	$"6368 0000 0064 7379 7376 0000 0088 7072"            /* ch...dsysv...pr */
	$"6F63 0000 0092 6670 7520 0000 009E 7164"            /* oc...fpu ...qd */
	$"2020 0000 00E8 6B62 6420 0000 011A 6174"            /*   ....kbd ....at */
	$"6C6B 0000 0142 6D6D 7520 0000 0164 7261"            /* lk...Bmmu ...dra */
	$"6D20 0000 0188 6C72 616D 0000 0188 0000"            /* m ...lram..... */
	$"0000 0000 0000 7001 6082 2278 02AE 7004"            /* ......p.`"x.p. */
	$"0C69 0075 0008 6712 0C69 0276 0008 6604"            /* .i.u..g..i.v..f. */
	$"5240 6006 1038 0CB3 5C80 6000 FF60 7000"            /* R@`..8.\`..`p. */
	$"3038 015A 6000 FF56 7000 1038 012F 5240"            /* 08.Z`..Vp..8./R@ */
	$"6000 FF4A 0C38 0004 012F 6738 0838 0004"            /* `..J.8.../g8.8.. */
	$"0B22 6734 204F F280 0000 F327 3017 2E48"            /* ."g4 O....'0..H */
	$"0C40 1F18 6716 0C40 3F18 6710 0C40 3F38"            /* .@..g..@?.g..@?8 */
	$"670E 0C40 1F38 6708 7000 600E 7001 600A"            /* g..@.8g.p.`.p.`. */
	$"7002 6006 7003 6002 7000 6000 FF00 0C78"            /* p.`.p.`.p.`....x */
	$"3FFF 028E 6E1C 303C A89F A746 2408 203C"            /* ?..n.0<F$. < */
	$"0000 AB03 A746 203C 0000 0100 B488 6606"            /* ...F <....f. */
	$"600A 7000 6006 203C 0000 0200 6000 FECE"            /* `.p.`. <....`.. */
	$"1038 021E 41FA 0016 2248 1218 6700 FED2"            /* .8..A..."H..g.. */
	$"B200 66F6 91C9 2008 6000 FEB2 0313 0B02"            /* .f. .`...... */
	$"0106 0704 0508 0900 7000 4A38 0291 6B16"            /* .......p.J8.k. */
	$"1238 01FB 0201 000F 0C01 0001 6608 2078"            /* .8..........f. x */
	$"02DC 1028 0007 6000 FE84 0C38 0002 012F"            /* ...(..`...8.../ */
	$"6D16 7000 1038 0CB1 0C00 0001 670C 0C00"            /* m.p..8.....g... */
	$"0003 6D04 5340 6002 7000 6000 FE60 303C"            /* ..m.S@`.p.`..`0< */
	$"A89F A746 2408 203C 0000 A88F A746 2038"            /* F$. <..F 8 */
	$"0108 B488 670A 598F 3F3C 0016 A88F 201F"            /* ..g.Y?<.. . */
	$"6000 FE3A 7402 205F 3F02 2F08 ADE9 7400"            /* `..:t. _?./..t. */
	$"4EFA FFF4 202F 0004 2F40 0008 6726 2040"            /* N... /../@..g& @ */
	$"2248 1019 671E 1211 12C0 1001 66F8 93C8"            /* "H..g......f. */
	$"2009 5340 0C80 0000 00FF 6F06 203C 0000"            /*  S@.....o. <.. */
	$"00FF 1080 225F 584F 4ED1 225F 201F 2E80"            /* ..."_XON"_ .. */
	$"6712 2040 7000 1010 6004 10E8 0001 51C8"            /* g. @p...`.....Q */
	$"FFFA 4210 4ED1"                                     /* ..B.N */
};

data 'CODE' (2, "%A5Init", purgeable) {
	$"0040 0001 48E7 7FF8 49FA 01A4 302C 0004"            /* .@..H...I..0,.. */
	$"5340 6704 70FF 6032 264D 97D4 2F0B 2F14"            /* S@g.p.`2&M/./. */
	$"6100 0148 202C 0008 4874 0800 2F0B 6100"            /* a..H ,..Ht../.a. */
	$"002E 504F 202C 000C 4874 0800 2F0B 2F0D"            /* ..PO ,..Ht.././ */
	$"6100 00CC 4FEF 000C 7000 4CDF 1FFE 4E75"            /* a..O...p.L...Nu */
	$"8009 5F44 4154 4149 4E49 5400 0000 226F"            /* _DATAINIT..."o */
	$"0004 206F 0008 48E7 1800 7601 7200 1218"            /* .. o..H...v.r... */
	$"2401 0241 000F 6608 6140 2200 6722 6002"            /* $..A..f.a@".g"`. */
	$"D241 0242 00F0 6606 6130 2400 6002 E64A"            /* A.B..f.a0$.`..J */
	$"D3C2 2801 12D8 5384 66FA 5383 66F2 60CA"            /* (..Sf.Sf.` */
	$"4CDF 0018 4E75 8010 756E 636F 6D70 7265"            /* L...Nu.uncompre */
	$"7373 5F77 6F72 6C64 0000 7000 1018 6A42"            /* ss_world..p...jB */
	$"0800 0006 6734 0800 0005 6720 0800 0004"            /* ....g4....g .... */
	$"670A 61E6 2600 61E2 C143 4E75 1018 E180"            /* g.a.&.a.CNu... */
	$"1018 E180 1018 E180 1018 4E75 0200 001F"            /* ........Nu.... */
	$"E180 1018 E180 1018 4E75 0200 003F E180"            /* ......Nu...?. */
	$"1018 4E75 8006 6765 745F 726C 0000 222F"            /* ..Nu.get_rl.."/ */
	$"0004 226F 0008 206F 000C 7401 7000 1018"            /* .."o.. o..t.p... */
	$"670C 6A26 0880 0007 E188 1018 601C 1018"            /* g.j&......`... */
	$"6724 6A0E E188 1018 E188 1018 E188 1018"            /* g$j.......... */
	$"6008 2400 6100 FF74 C142 D080 D3C0 D391"            /* `.$.a..tBЀӑ */
	$"5382 66F8 60C4 4E75 800E 7265 6C6F 6361"            /* Sf.`Nu.reloca */
	$"7465 5F77 6F72 6C64 0000 7400 205F 201F"            /* te_world..t. _ . */
	$"225F 6728 3209 0241 0003 6708 12C2 5380"            /* "_g(2.A..g..S */
	$"66F2 6018 2200 E489 6706 22C2 5381 66FA"            /* f.`."..g."Sf. */
	$"0240 0003 6002 12C2 51C8 FFFC 4ED0 800A"            /* .@..`..Q..NЀ. */
	$"5A45 524F 4255 4646 4552 0000 0000 0000"            /* ZEROBUFFER...... */
	$"02DA 0001 0000 0000 0014 0000 00D5 0000"            /* ............... */
	$"0000 0900 1154 6869 7320 446F 6573 204E"            /* ....This Does N */
	$"6F74 6869 6E67 1461 6576 746F 6170 7000"            /* othing.aevtoapp. */
	$"F009 0403 2A61 6576 746F 646F 6332 6165"            /* ...*aevtodoc2ae */
	$"7674 7175 6974 4261 6576 7470 646F 633A"            /* vtquitBaevtpdoc: */
	$"5369 6D70 5349 4D50 0003 034A 0001 0003"            /* SimpSIMP...J.... */
	$"2D01 0002 0053 80DA 2825 5F53 7461 7469"            /* -....S.(%_Stati */
	$"635F 436F 6E73 7472 7563 746F 725F 4465"            /* c_Constructor_De */
	$"7374 7275 6374 6F72 5F50 6F69 6E74 6572"            /* structor_Pointer */
	$"7300 2825 5F53 7461 7469 635F 436F 6E73"            /* s.(%_Static_Cons */
	$"7472 7563 746F 725F 4465 7374 7275 6374"            /* tructor_Destruct */
	$"6F72 5F50 6F69 6E74 6572 7340 0301 5348"            /* or_Pointers@..SH */
	$"2009 FFFF FF12 FFFF FF1A 8102 07FF FFFF"            /*  ............. */
	$"1E10 000E 0006 0480 B902 0600 0000 0000"            /* .............. */
	$"01AE 6D70 7764"                                     /* .mpwd */
};

